## gnuplot 5.4.1+dfsg1

=== config/mingw/Makefile ===
# Hello, emacs: this is a -*- Makefile -*-
#
# GNUPLOT Makefile for MinGW/MSYS or MinGW-w64/MSYS2 on Windows 
#
# Note: Currently MinGW cannot be used to compile gnuplot unless
#       libraries / headers are updated.
# Note that Mingw-w64 needs to be configured with --enable-secure-api, and
#       MINGW_HAS_SECURE_API must be defined in _mingw.h.
#
# See http://www.mingw.org or http://msys2.github.io/ for more details.

# To compile gnuplot for Windows:
# - Change the configuration section in 'config/mingw/Makfile' to
#   match your setup.
# - On the MSYS/MSYS2 prompt, change directory to 'config/mingw' and issue
#   the commands
#	 make all
#	 make install
#
# This makefile was tested with 
#   MSYS, MinGW32 and Microsoft HTML Help 1.4 SDK.
#   MSYS2, MinGW-w64


#
# ************** Begin of Configuration section ************************
#

# Choose target to compile:
# 1. PLAIN: wgnuplot.exe: The usual Windows GUI for input commands.
# 2. PIPES: wgnuplot_pipes.exe: Like wgnuplot, but with an additional console
#    window, so you can see the output of commands like
#      plot '<awk -f preprocess.awk my.dat')  or  x=system('ls -1')
# 3. CONSOLE: gnuplot.exe: Console mode instead of GUI for the text input.
#

# Enable exactly one of these:
VARIANT = PLAIN
#VARIANT = PIPES
#VARIANT = CONSOLE

# Comment out the definition lines to disable the according features:

# Define this only if doing a release build
RELEASE=1

# Set-up your compiler environment
#
# Define if you are using MSYS2/MinGW64 instead of MSYS/MinGW
MINGW64=1
# Define if you want a 32bit version (even using a 64bit compiler)
#M32=1
# Define if you use clang instead of gcc, requires MINGW64
#CLANG=1
# Use the colorgcc frontend explicitly
#COLORGCC=1
# Specify the path to the compiler unless it is already in PATH
#CCPATH = g:/mingw32/bin/
#CCPATH = c:/apps/mingw/bin/

# Path to 32bit programs
# On 32bit machines:
#PROGRAMFILES32="$(PROGRAMFILES)"
#PROGRAMFILES32=/c/Program\ Files
# On 64bit machines: (no access to ProgramFiles(x86) variable!)
PROGRAMFILES32=/c/Program\ Files\ \(x86\)

# Define if you would like a UNICODE build
UNICODE=1

# GIF, PNG, JPEG device drivers
# Requires gd library. There are two possibilities how to configure these
# drivers for use in gnuplot, depending on the gd version. See README.1ST for
# more details.
#
# You should compile gnuplot with GD library v2.0 or newer.
# This library writes PNG, GIF and JPEG images.
# If libgd has been compiled with TrueType font support, then you can use
# scaled TrueType fonts. If not, then uncomment FREETYPE.
# Requires GD, PNG and Z libraries, optionally libfreetype.
# In some cases, libfreetype can depend on additional libraries such as
# fontconfig or iconv; then, uncomment GDAUTOCONFIGLIBS so that all of the
# libraries needed for linking will be taken by running 'gdlib-config'.
# Uncomment BGD if you want to use the binary DLL version of libgd.
#NEWGD=1
#JPEG=1
#FREETYPE=1
#GDAUTOCONFIGLIBS=1
#GDPKGCONFIG=1
#BGD=1

# PDF device driver
# Requires PNG and Z libraries based on particular PDF library used, and
# optionally also TIFF library according to
# 1. defined PDF_NOTIFF:
#    'Light' pdf library (produces wgnuplot.exe only 200 KB larger!)
#    You can get this pdf library by compiling it without PNG, GD and TIFF
#    support: change  pdflib/p_intern.h  and recompile the pdf library.
#    Gnuplot does not use the tiff routines, and gd/png are elsewhere.
# 2. undefined PDF_NOTIFF:
#    Full pdf library (produces wgnuplot.exe 500 KB larger!)
#PDF=1
#PDF_NOTIFF=1

# DEBUGging support
# creates binaries suitable for debugging. Some bugs may come and go
# as opposed to a production build since we lower the optimization level
#DEBUG=1

# MOUSE support for the windows terminal
MOUSE=1

# Cairo/Pango terminals
# Uncomment the following lines to select the pngcairo and pdfcairo
# terminals
#CAIROTERMS=1
#CAIROLIBS=1

# WXWIDGETS interactive terminal
# Requires wxWidgets, Cairo, Pango, and their respective dependencies.
# Uncomment the following lines to compile it.
#WXT=1
#CAIROLIBS=1

# Build qt terminal?
#QT=1
# specify QT installation directory
#QT_DIR = /c/Qt/5.2.1/mingw48_32
ifndef MINGW64
QT_DIR = /d/Source/Qt-5.2.1-mingw/5.2.1/mingw48_32
else
ifdef M32
QT_DIR = /mingw32
else
QT_DIR = /mingw64
endif
endif

# Uncomment the following line to select the lua/tikz terminal
#LUA=lua

# Uncomment the following line to select the caca terminal
# Requires libcaca version 0.99.beta15 or newer. A post-beta18
# svn version is recommended since it contains an improved
# win32 backend.
#CACA=1

# Uncomment if you have libiconv
ICONV=1

# Uncomment if you have libcerf
# http://sourceforge.net/projects/libcerf/
CERF=1

# Uncomment if console mode gnuplot should use GNU readline
# (not recommended)
#GNUREADLINE=1

# Uncomment if you want to use Direct2D 1.1 (Windows 8 and Windows 7 Platform Update)
DIRECT2D11=1

# GRX graphics library, for debugging the DJGPP svga terminal
#GRX=1
GRXPATH=c:/Source/grx249
# or, the MGRX fork of GRX
#MGRX=1
MGRXPATH=c:/Source/mgrx110


# Below you can adapt paths according to your software setup:

# Where to install the PostScript prologue files, relatively to the
# executable in bin/wgnuplot.exe
GNUPLOT_PS_DIR = share/PostScript

# Similarly for javascript files for the canvas terminal:
GNUPLOT_JS_DIR = share/js

# Similarly for translation files for the qt terminal:
GNUPLOT_QT_DIR = share/qt

# Similarly for scripts used by the lua terminal
GNUPLOT_LUA_DIR = share/lua

# Install will put TeX files here:
GNUPLOT_TEX_DIR = share/texmf/tex

# gnuplot will look for gnuplotrc here:
GNUPLOT_SHARE_DIR = share

# Destination directory, used in 'make install':
#DESTDIR = /local/opt/gnuplot-4.5
DESTDIR = "$(PROGRAMFILES)/gnuplot"

# Do you want some special optimization / flags?
#CFLAGS +=
CWFLAGS += -Wno-unused-function
ifdef CLANG
CFLAGS += -fcolor-diagnostics -fansi-escape-codes
CWFLAGS += -Wno-incompatible-ms-struct -Wno-ignored-attributes
CWFLAGS += -Wno-infinite-recursion
CXXFLAGS += -std=c++11
endif
ifdef MINGW64
# This does not seem to work even if GCC_COLORS is set.
#CFLAGS += -fdiagnostics-color=always
endif

# To compile the .chm file you need the Microsoft HTML Help 1.4 SDK
# It can be obtained here:
# http://go.microsoft.com/fwlink/?LinkId=154968
# We need to explicitly set the correct path here since we also need
# adjust the include and library paths.
HHWPATH = $(PROGRAMFILES32)/HTML\ Help\ Workshop/
HHC = $(HHWPATH)hhc

# Choose which resource compiler you want to use (GNU windres or MS rc):
GNU_RC = 1
ifndef GNU_RC
  # If uncommented GNU_RC above and rc.exe not in PATH, then set:
  MSSDK = c:/mssdk
endif

# GNU sort
GNUSORT = /bin/sort

# Inno Setup Compiler
# get it from: http://www.jrsoftware.org/isdl.php
# Use the Unicode version of Inno Setup Compiler
ISCC = $(PROGRAMFILES32)/Inno\ Setup\ 6/iscc

#DLLS = 1

# Directory that might contain extra files to be shipped with the installer.
# This should include dependencies like DLLs, but also fontconfig configuration files.
ifdef MINGW64
ifdef M32
#EXTRADIST = /d/gnuplot/dist32
else
#EXTRADIST = /d/gnuplot/dist64
endif
else
#EXTRADIST = /d/gnuplot/dist
endif

#
# *************** End of Configuration section *************************
#


#         There shouldn't be anything to be changed below this line
# **********************************************************************
#

# We enforce to use console mode gnuplot to run gnuplot scripts in order
# to see their output during make.
TARGET=gnuplot.exe

ifdef MINGW64
ifdef M32
CFLAGS += -m32
else
CFLAGS += -m64
endif
else
# MINGW32 always produces 32bit executables
ifndef M32
M32=1
endif
endif

ifndef CLANG
ifdef COLORGCC
CC=$(CCPATH)color-gcc
CXX=$(CCPATH)color-g++
else # !COLORGCC
ifdef (CCPATH)
CC = $(CCPATH)gcc
CXX = $(CCPATH)g++
else #!CCPATH
CC = gcc
CXX = g++
endif
endif
else # CLANG
CC = $(CCPATH)clang
CXX = $(CCPATH)clang++
endif
LD = $(CC)
LDX = $(CXX)

RM = rm -f
CP = cp -p

ifdef DEBUG
  CFLAGS += -g -Wall -pipe
  LDFLAGS += -g
else
  CFLAGS += -O2 -pipe
  LDFLAGS += -s
endif

ifdef UNICODE
  CFLAGS += -DUNICODE -D_UNICODE
endif

CFLAGS += $(CWFLAGS)

TOP = ../..

# macros for makefile.all
O=o
S=$(TOP)/src
W=$(S)/win
T=$(TOP)/term/
D=$(TOP)/docs/
M=$(TOP)/demo/

VPATH = $(S):$(S)/wxterminal

CFLAGS += -DGNUPLOT_PS_DIR=\"$(GNUPLOT_PS_DIR)\" 
TERMFLAGS = -DGNUPLOT_JS_DIR=\"$(GNUPLOT_JS_DIR)\"
TERMFLAGS += -I$(TOP)/term

TERMLIBS =

CFLAGS += -I. -I$(S) -I$(T) -DHAVE_CONFIG_H
CFLAGS += -D__USE_MINGW_ANSI_STDIO=1
CFLAGS += -DGNUPLOT_SHARE_DIR=\"$(GNUPLOT_SHARE_DIR)\"

ifndef RELEASE
  CFLAGS += -DDEVELOPMENT_VERSION
endif

ifdef MOUSE
  CFLAGS += -DUSE_MOUSE=1 -DWIN_IPC
endif

# Name of helpfiles:
HELPFILE = wgnuplot.chm
HELPFILEJA = wgnuplot-ja.chm
CFLAGS += -I$(HHWPATH)include
BUILDHELPFILE = $(D)windows/$(HELPFILE)

ifdef NEWGD
  GD=1
  PNG=1
endif

ifdef GD
  CFLAGS += -DHAVE_LIBGD
  ifndef BGD
    TERMLIBS += -lgd
  else
    TERMLIBS += -lbgd
  endif
endif

ifdef PNG
  CFLAGS += -DHAVE_LIBPNG
  ifndef BGD
  ifndef GDAUTOCONFIGLIBS
  ifndef GDPKGCONFIG
    TERMLIBS += -lpng -lz
  endif
  endif
  endif
endif

ifdef NEWGD
  CFLAGS += -DHAVE_LIBGD -DHAVE_GD_H -DHAVE_GD_GIF -DGIF_ANIMATION -DHAVE_GD_PNG
ifdef GDPKGCONFIG
  CFLAGS += $(shell pkg-config --cflags gdlib)
endif
ifdef JPEG
  CFLAGS += -DHAVE_GD_JPEG
  ifndef BGD
  ifndef GDAUTOCONFIGLIBS
  ifndef GDPKGCONFIG
    TERMLIBS += -ljpeg
  endif
  endif
  endif
endif
ifdef FREETYPE
  CFLAGS += -DHAVE_GD_TTF
  ifndef BGD
  ifndef GDAUTOCONFIGLIBS
  ifndef GDPKGCONFIG
    TERMLIBS += -lfreetype
  endif
  endif
  endif
endif
ifdef GDAUTOCONFIGLIBS
  TERMLIBS += $(shell gdlib-config --libs)
endif
ifdef GDPKGCONFIG
  TERMLIBS += $(shell pkg-config --libs gdlib)
endif
endif

ifdef PDF
  CFLAGS += -DHAVE_LIBPDF
ifdef PDF_NOTIFF
  TERMLIBS += -lpdf_notiff
else
  TERMLIBS += -lpdf -ltiff
#  TERMLIBS += -lpdf-w -ltiff-w
endif
ifndef PNG
  NEED_PNG_W = 1
else
ifndef NEWGD
  NEED_PNG_W = 1
endif
endif
ifdef NEED_PNG_W
  CFLAGS += -DHAVE_LIBPNG
  TERMLIBS += -lpng-w -lz-w
endif
endif

ifdef CAIROLIBS
	CAIRO_CFLAGS := $(shell pkg-config --cflags cairo | sed s_-Ic:_-I/c_g)
	PANGOCAIRO_CFLAGS := $(shell pkg-config --cflags glib-2.0 gobject-2.0 pangocairo cairo | sed s_-Ic:_-I/c_g)
	PANGOCAIRO_LIBS := $(shell pkg-config --libs glib-2.0 gobject-2.0 pangocairo cairo | sed s_-Lc:_-L/c_g)
	CAIRO_OBJS := gp_cairo.$(O) gp_cairo_helpers.$(O)
	TERMFLAGS += $(PANGOCAIRO_CFLAGS)
endif

ifdef CAIROTERMS
	CFLAGS += -DHAVE_CAIROPDF
	TERMFLAGS += -DHAVE_CAIROEPS
endif

ifdef WXT
	CFLAGS += -DWXWIDGETS
	WXT_CXXFLAGS := $(shell wx-config --cxxflags)
	CXXFLAGS += $(WXT_CXXFLAGS)
	WX_LIBS := $(shell wx-config --libs | sed -e "s+-Wl,--subsystem,windows++g" -e "s+-mwindows++g")
	WX_OBJS = wxt_gui.$(O)
endif

ifdef QT
	QT_LIBS = -lQt5Core -lQt5Gui -lQt5Network -lQt5Svg -lQt5Widgets -lQt5PrintSupport -lqtmain
	QT_CXXFLAGS =  -I$(QT_DIR)/include -I$(QT_DIR)/include/Qt -I$(QT_DIR)/include/QtCore -I$(QT_DIR)/include/QtGui
	QT_CXXFLAGS += -I$(QT_DIR)/include/QtWidgets -I$(QT_DIR)/include/QtNetwork
	QT_CXXFLAGS += -I$(QT_DIR)/include/QtSvg -DQTGNUPLOT_DATA_DIR=\"$(GNUPLOT_QT_DIR)\"
	QT_LDFLAGS = -L$(QT_DIR)/lib

	CFLAGS += -DQTTERM -DQT_NO_OPENGL
	TERMLIBS += $(QT_LIBS)
	CXXFLAGS += $(QT_CXXFLAGS)
	LDFLAGS  += $(QT_LDFLAGS)
	QT_OBJS = qt_term.$(O) 
	GNUPLOTQTOBJS = gnuplot_qt.o QtGnuplotWindow.o \
		QtGnuplotApplication.o QtGnuplotWidget.o \
		QtGnuplotScene.o QtGnuplotItems.o \
		QtGnuplotEvent.o \
		moc_QtGnuplotWindow.o moc_QtGnuplotApplication.o \
		moc_QtGnuplotWidget.o moc_QtGnuplotScene.o \
		moc_QtGnuplotEvent.o qrc_QtGnuplotResource.o

	MOC = $(QT_DIR)/bin/moc
	UIC = $(QT_DIR)/bin/uic
	RCC = $(QT_DIR)/bin/rcc
	LRELEASE = $(QT_DIR)/bin/lrelease
	QT_FILES_TARGETS  = qrc_QtGnuplotResource.cpp ui_QtGnuplotSettings.h moc_QtGnuplotWindow.cpp moc_QtGnuplotApplication.cpp 
	QT_FILES_TARGETS += moc_QtGnuplotWidget.cpp moc_QtGnuplotScene.cpp moc_QtGnuplotEvent.cpp

=== config/watcom/Makefile ===
# Hello, emacs: this is a -*- Makefile -*-
#
# GNUPLOT Makefile OpenWatcom 1.3 on Win32

# To compile:
#       Either, from ..\src:
#         wmake -f ..\config\makefile.oww
#       or copy this file to ..\src, edit it to your liking, then
#       from ..\src:
#         wmake -f makefile.oww
# 
# History of this file:
# 2004-02-23: Created by massive editing of makefile.nt (and config.nt)
# 2004-04-25: Removed all remaining MS-isms (by peeking at how OW's
#  MS namesake replacement tools generate their command lines)
#

# enable exactly one of these:
VARIANT = PLAIN
#VARIANT = PIPES
#VARIANT = CONSOLE

TOP = ..\..

# Programs: 
# The Microsoft Help compiler:
HCW = "c:\program files\help workshop\hcw.exe"
# ... and the HTML help compiler
HHC_DIR = c:\Program Files\HTML Help Workshop
HHC = "$(HHC_DIR)\hhc.exe"

# OpenWatcom programs:
WCL = wcl386
WCC = wcc386
WPP = wpp386
WLD = wlink
WRC = wrc

# Speed up compilation a bit by running the compiler as a DLL from
# inside wmake:
!ifdef __LOADDLL__
!  loaddll wcc      wccd
!  loaddll wccaxp   wccdaxp
!  loaddll wcc386   wccd386
!  loaddll wpp      wppdi86
!  loaddll wppaxp   wppdaxp
!  loaddll wpp386   wppd386
!  loaddll wlink    wlinkd
!  loaddll wlib     wlibd
!endif

# Where to install the PostScript prologue files, relatively to the executable
# wgnuplot.exe
GNUPLOT_PS_DIR = share/PostScript

# paths for external libs added here... 
LDLIBS = 

# Optional libraries:
# GDI+ and Direct2D/DirectWrite support libraries are available at
#   https://sourceforge.net/p/gnuplot/patches/746/
#GDIPLUS=1
#DIRECT2D=1

# Macros for makefile.all
O=obj
T=$(TOP)\term\
D=$(TOP)\docs\
M=$(TOP)\demo\
S=$(TOP)\src
W=$(S)\win

BINARYFILES=$(M)binary1 $(M)binary2 $(M)binary3

# compiler flags: 
#
# Defines

CPPFLAGS =  -DHAVE_CONFIG_H -DHAVE_CONFIG_H -DUSE_MOUSE -DPIPES
CPPFLAGS += -DVERSION_MAJOR="5.4" -DPATCHLEVEL="0"
CPPFLAGS += -DUNICODE -D_UNICODE
# library-dependent ones may have to be added, like:
# -DHAVE_LIBPNG -DHAVE_LIBPDF
!ifdef GDIPLUS
CPPFLAGS += -DHAVE_GDIPLUS
!endif
!ifdef DIRECT2D
CPPFLAGS += -DHAVE_D2D
!endif
!ifndef GDIPLUS 
!ifndef DIRECT2D
# fall back to GDI if everything else fails
CPPFLAGS += -DUSE_WINGDI
!endif
!endif

HELPFILE = wgnuplot.chm

DEFAULT_TARGETS = $(BINARYFILES) $(HELPFILE)

TARGETS_PLAIN=wgnuplot.exe wgnuplot.mnu
EXTRA_CPPFLAGS_PLAIN = -DUSE_FAKEPIPES

TARGETS_PIPES=wgnuplot_pipes.exe wgnuplot.mnu
EXTRA_CPPFLAGS_PIPES = 

TARGETS_CONSOLE=gnuplot.exe
EXTRA_CPPFLAGS_CONSOLE = -DWGP_CONSOLE

ALL_TARGETS = $(DEFAULT_TARGETS) $(TARGETS_PLAIN) $(TARGETS_PIPES) $(TARGETS_CONSOLE)

DEFAULT_TARGETS += $(TARGETS_$(VARIANT))

LDLIBS += LIBRARY htmlhelp.lib
!ifdef GDIPLUS
LDLIBS += LIBRARY gdiplus.lib
!endif
!ifdef DIRECT2D
LDLIBS += LIBRARY d2d1.lib LIBRARY dwrite.lib
!endif

# compiler flags, determined from MS ones by OW's "cl /showwopts"

# -c  : don't link
# -I  : add directory to include search path
# -zq : don't show a version banner message
# -5r : P5-optimized, 386-compatible code, register calling convention
# -zm : put each function in its own section to improve dead code elimination
# -bm : target multi-threaded environment
# -sg : grow the stack if needed
# -zlf: store library usage in .obj files
# -ei : force sizeof(enum) >= sizeof(int)
# -o  : optimization options:   
#    r:   reorder for pipelining
#    i:   inline intrinsics
#    l:   loop optimizations
#    t:   optimize for speed
# -j  : char is signed
# -aa : allow non-const initializers for locals
# -d2 : debug information
WCFLAGS = -zlf -ei -zq -I$(S);$(W) -zm -bm -5r -sg -orilt -aa -d2 $(CPPFLAGS) $(OPTS)
WPPFLAGS = -zlf -ei -zq -I$(S);$(W) -zm -bm -5r -sg -orilt -xs -d2 $(CPPFLAGS) $(OPTS)
# removed: -za99

# ...and here.
# see other terminal defines in term.h
TERMFLAGS = -DGNUPLOT_PS_DIR="$(GNUPLOT_PS_DIR)" -I$(T)

# Note: like makefile.wc, this need the special Watcom-style version of
# makefile.all, because line continuation in WMake is different...
!INCLUDE $(S)\makefile.awc

default: $(DEFAULT_TARGETS) .SYMBOLIC

all: $(ALL_TARGETS) .SYMBOLIC

WINOBJS = winmain.$(O) wgnuplib.$(O) wgraph.$(O) wprinter.$(O) wtext.$(O) &
          wpause.$(O) wmenu.$(O) gpexecute.$(O) screenbuf.$(O)
!ifdef GDIPLUS
WINOBJS = $(WINOBJS) wgdiplus.$(O)
!endif
!ifdef DIRECT2D
WINOBJS = $(WINOBJS) wd2d.$(O)
!endif

OBJS = $(COREOBJS) version.$(O) $(WINOBJS)

O=cobj
CONSOLE_OBJS = $+ $(OBJS) $-
O=pobj
PIPE_OBJS = $+ $(OBJS) $-
O=obj

WIN_EXTRA_INPUTS = wgnuplot.res

# extensions:
.EXTENSIONS:
.EXTENSIONS: .exe .cobj .pobj .obj .asm .pas .c .cpp .for

.c: $(S);$(W)
.cpp: $(S);$(W)

# default rule
.c.obj: .AUTODEPEND
	$(WCC) $(EXTRA_CPPFLAGS_PLAIN) $(WCFLAGS) $[@

.c.cobj: .AUTODEPEND
	$(WCC) $(EXTRA_CPPFLAGS_CONSOLE) $(WCFLAGS) $[@ -fo=$^@

.c.pobj: .AUTODEPEND
	$(WCC) $(EXTRA_CPPFLAGS_PIPES) $(WCFLAGS) $[@ -fo=$^@

.cpp.obj: .AUTODEPEND
	$(WPP) $(EXTRA_CPPFLAGS_PLAIN) $(WPPFLAGS) $[@

.cpp.cobj: .AUTODEPEND
	$(WPP) $(EXTRA_CPPFLAGS_CONSOLE) $(WPPFLAGS) $[@ -fo=$^@

.cpp.pobj: .AUTODEPEND
	$(WPP) $(EXTRA_CPPFLAGS_PIPES) $(WPPFLAGS) $[@ -fo=$^@

# file-specific rules
wgnuplot.exe: $(OBJS) $(WIN_EXTRA_INPUTS)
        $(WLD) @<<linkopt1.oww $(LDLIBS)
RUNTIME windows=4.0
SYSTEM nt_win
DEBUG ALL
OPTION quiet
FILE {
 $(OBJS)
}
LIBRARY kernel32.lib,user32.lib,gdi32.lib,winspool.lib,comdlg32.lib
LIBRARY comctl32.lib,advapi32.lib,shell32.lib
LIBRARY msimg32.lib
LIBRARY shlwapi.lib
OPTION map
OPTION SYMFILE
NAME $^&
OPTION stack=1M
OPTION resource=wgnuplot.res
OPTION ELIMINATE
REFERENCE _wstart_ 
OPTION START=_wstart_
<<

wgnuplot_pipes.exe: $(PIPE_OBJS) $(WIN_EXTRA_INPUTS)
        $(WLD) @<<linkopt1.oww $(LDLIBS)
RUNTIME windows=4.0
SYSTEM nt_win
DEBUG ALL
OPTION quiet
FILE {
 $(PIPE_OBJS)
}
LIBRARY kernel32.lib,user32.lib,gdi32.lib,winspool.lib,comdlg32.lib
LIBRARY advapi32.lib,shell32.lib
LIBRARY msimg32.lib
LIBRARY shlwapi.lib
OPTION map
OPTION SYMFILE
NAME $^&
OPTION stack=1M
OPTION resource=wgnuplot.res
OPTION ELIMINATE
REFERENCE _wstart_ 
OPTION START=_wstart_
<<

gnuplot.exe: $(CONSOLE_OBJS) $(WIN_EXTRA_INPUTS) 
        $(WLD) @<<linkopt1.oww $(LDLIBS)
RUNTIME console=4.0
SYSTEM nt
DEBUG ALL
OPTION quiet
FILE {
 $(CONSOLE_OBJS)
}
LIBRARY kernel32.lib,user32.lib,gdi32.lib,winspool.lib,comdlg32.lib
LIBRARY advapi32.lib,shell32.lib
LIBRARY msimg32.lib
LIBRARY shlwapi.lib
OPTION map
OPTION SYMFILE
NAME gnuplot.exe
OPTION stack=1M
OPTION resource=wgnuplot.res
OPTION ELIMINATE
#REFERENCE _wstart_ 
#OPTION START=_wstart_
<<keep

# NOTE: Unknown what /l 0x409 does in MS RC call --- seems to work without, though
wgnuplot.res :  $(W)\wgnuplot.rc $(W)\wgnuplib.rc &
  $(W)\wresourc.h $(W)\texticon.ico $(W)\grpicon.ico
        $(WRC) -r -q -bt=nt -fowgnuplot.res -i=$(W) &
	   -d_WIN32 -dNDEBUG -dWIN32 $(W)\wgnuplot.rc

term.obj: $(S)\term.c $(CORETERM) .AUTODEPEND
        $(WCC) $(EXTRA_CPPFLAGS_PLAIN) $(WCFLAGS) $(TERMFLAGS) $[@
term.cobj: $(S)\term.c $(CORETERM) .AUTODEPEND
        $(WCC) $(EXTRA_CPPFLAGS_CONSOLE) $(WCFLAGS) $(TERMFLAGS) $[@ -fo=$^@
term.pobj: $(S)\term.c $(CORETERM) .AUTODEPEND
        $(WCC) $(EXTRA_CPPFLAGS_PIPES) $(WCFLAGS) $(TERMFLAGS) $[@ -fo=$^@

wgnuplot.mnu: $(W)\wgnuplot.mnu
        copy $(W)\wgnuplot.mnu wgnuplot.mnu

pgnuplot.exe: $(W)\pgnuplot.c version.$(O) .AUTODEPEND
        $(WCL) -DWINDOWS_NO_GUI -5r -zq -d2 -fm $(W)\pgnuplot.c -fe=pgnuplot.exe -I$(S) &
	  version.$(O) user32.lib


WD=$(D)windows\
HHP_PROJ=$(WD)wgnuplot.hhp
HHP_CONTENT=$(WD)wgnuplot.hhc
HHP_INPUT=$(WD)wgnuplot.html
HHP_OUTPUT=$(WD)wgnuplot.chm   

wgnuplot.chm: $(HHP_OUTPUT)
        copy $(HHP_OUTPUT) .

$(HHP_OUTPUT): $(HHP_PROJ) $(HHP_INPUT) $(HHP_CONTENT)
        -$(HHC) $(HHP_PROJ)

$(HHP_INPUT) $(HHP_CONTENT): doc2html.exe $(D)gnuplot.doc
        doc2html $(D)gnuplot.doc $(WD)

doc2html.exe: $(WD)doc2html.c $(D)termdoc.c $(D)xref.c version.$(O) .AUTODEPEND
        $(WCL) $(WCFLAGS) -w1 -DWINDOWS_NO_GUI -I$(D);$(T) -fe$^@ $(WD)doc2html.c $(D)termdoc.c $(D)xref.c version.$(O)

gnuplot.gih: doc2gih.exe $(D)gnuplot.doc
        doc2gih $(D)gnuplot.doc $^@

doc2gih.exe: $(D)doc2gih.c $(D)termdoc.c $(D)xref.c .AUTODEPEND
        $(WCL) $(EXTRA_CPPFLAGS_CONSOLE) $(WCFLAGS) -w1 -I$(D);$(T) -fe$^@ $(D)doc2gih.c $(D)termdoc.c $(D)xref.c

#make binary demo files
# WINDOWS_NO_GUI makes sure that wtext.h does not redefine fread() etc.
bf_test.exe : bf_test.c  .AUTODEPEND
        $(WCL) $(WCFLAGS) -w1 -DWINDOWS_NO_GUI -fe$^@ $(S)\bf_test.c

$(BINARYFILES): bf_test.exe
        .\bf_test
        move binary? $(M).

dbinary.$(O): $(S)\binary.c
        $(WCC) $(WCFLAGS) -w1 -DWINDOWS_NO_GUI -fodbinary.$(O) $[@

# clean up temporary files
clean: .SYMBOLIC
        rm -f *.obj *.cobj *.pobj *.err
        rm -f wgnuplot.res $(W)\gnuplot.rtf $(W)\wgnuplot.hlp
        rm -f bf_test.exe linkopt1.oww doc2html.exe
        rm -f doc2gih.exe gnuplot.gih
        rm -f *.map *.sym wgnuplot.gid        

realclean: clean .SYMBOLIC
        rm -f wgnuplot.exe wgnuplot.mnu pgnuplot.exe gnuplot.exe wgnuplot_pipes.exe
        rm -f $(HHP_CONTENT) $(HHP_INPUT) $(HHP_OUTPUT) $(WD)wgnuplot.log
        rm -f wgnuplot.hlp wgnuplot.chm wgnuplot.chw
        rm -f $(D)binary[123] $(D)fit.log $(D)soundfit.par

=== demo/html/Makefile ===
all: html showcase_plots

distclean: clean
clean:
	rm -f *.png *.gnu *.html *.dat epslatex* fit.log soundfit.par *.tmp *.js *.?.svg *.??.svg gnuplot_mouse.css jsdir

GNUPLOT_LIB = ..

#
# Auto-generation of the html demo set using the png terminal.
#
# Several of the demos need manual intervention:
#	fontfile vector epslatex
#
html: airfoil.html approximate.html armillary.html array.html arrowstyle.html barchart_art.html binary.html bins.html bivariat.html boxplot.html boxclusters.html candlesticks.html cerf.html circles.html cities.html complex_trig.html columnhead.html contours.html custom_contours.html controls.html custom_key.html dashtypes.html datastrings.html dgrid3d.html discrete.html electron.html ellipse.html enhanced_utf8.html epslatex.html errorbars.html fenceplot.html fillbetween.html fillcrvs.html fillstyle.html finance.html fit.html hidden.html hidden2.html hidden_compare.html histograms.html histograms2.html gantt.html image.html image2.html imageNaN.html index.html iterate.html jitter.html label_stacked_histograms.html layout.html lines_arrows.html linkedaxes.html map_projection.html margins.html monotonic_spline.html multiaxis.html multiplt.html nokey.html nonlinear1.html nonlinear2.html nonlinear3.html parallel.html param.html piecewise.html pixmap.html pm3dcolors.html pm3d.html pm3dgamma.html pm3d_clip.html pm3d_lighting.html pointsize.html polar.html poldat.html polar_quadrants.html polygons.html prob2.html prob.html projection.html rainbow.html random.html rectangle.html rgba_lines.html rgbalpha.html rgb_variable.html rotate_labels.html rugplot.html running_avg.html sampling.html scatter.html simple.html singulr.html smooth.html solar_path.html spiderplot.html spline.html smooth_splines.html steps.html stringvar.html surface1.html surface2.html azimuth.html transparent.html transparent_solids.html textbox.html tics.html timedat.html ttics.html using.html varcolor.html vector.html violinplot.html walls.html world.html world2.html animate2.html heatmaps.html stats.html unicode.html zerror.html boxes3d.html voxel.html vplot.html isosurface.html

index.html: index.save
	cp index.save index.html
	cp ../../term/js/*.png .

circles.html: $(GNUPLOT_LIB)/hidden2.dem ./webify.pl
	export DEMOTERM="pngcairo truecolor font 'arial,8' size 500,300"; ./webify.pl circles

cities.html: $(GNUPLOT_LIB)/cities.dem ./webify.pl
	export DEMOTERM="pngcairo font 'Times,8' fontscale 2.5 size 500,500"; ./webify.pl cities

ellipse.html: random.html

hidden2.html: $(GNUPLOT_LIB)/hidden2.dem ./webify.pl
	export DEMOTERM="pngcairo font 'arial,8' size 540,384"; ./webify.pl hidden2

image.html: $(GNUPLOT_LIB)/image.dem ./webify.pl
	export DEMOTERM="pngcairo font 'arial,8' size 540,384"; ./webify.pl image

image2.html: $(GNUPLOT_LIB)/image2.dem ./webify.pl
	export DEMOTERM="pngcairo font 'arial,8' size 540,384"; ./webify.pl image2

rgbalpha.html: $(GNUPLOT_LIB)/rgbalpha.dem ./webify.pl
	export DEMOTERM="pngcairo font 'arial,8' size 540,360"; ./webify.pl rgbalpha

rgb_variable.html: $(GNUPLOT_LIB)/rgb_variable.dem ./webify.pl
	export DEMOTERM="pngcairo font 'arial,8' size 540,360"; ./webify.pl rgb_variable

rugplot.html: random.html

finance.html: $(GNUPLOT_LIB)/finance.dem ./webify.pl
	export DEMOTERM="pngcairo transparent font 'arial,8' size 660,320"; ./webify.pl finance

linkedaxes.html: $(GNUPLOT_LIB)/linkedaxes.dem ./webify.pl
	export DEMOTERM="pngcairo enhanced font 'arial,9' size 610,320"; ./webify.pl linkedaxes 


multiplt.html: $(GNUPLOT_LIB)/multiplt.dem ./webify.pl
	export DEMOTERM="pngcairo transparent font 'arial,8' size 610,480"; ./webify.pl multiplt

transparent.html: $(GNUPLOT_LIB)/transparent.dem ./webify.pl
	export DEMOTERM="pngcairo transparent truecolor font 'arial,8' size 512,280"; ./webify.pl transparent

transparent_solids.html: $(GNUPLOT_LIB)/transparent_solids.dem ./webify.pl
	export DEMOTERM="pngcairo truecolor font 'arial,9' size 512,384"; ./webify.pl transparent_solids

# The png terminal does not support dashed lines, so let's use pngcairo
lines_arrows.html: $(GNUPLOT_LIB)/lines_arrows.dem ./webify.pl
	export DEMOTERM="pngcairo dash dl 2"; ./webify.pl lines_arrows

rgba_lines.html: $(GNUPLOT_LIB)/rgba_lines.dem ./webify.pl
	export DEMOTERM="pngcairo dash dl 2"; ./webify.pl rgba_lines

complex_trig.html: $(GNUPLOT_LIB)/complex_trig.dem ./webify.pl
	export DEMOTERM="pngcairo enhanced font 'times'"; ./webify.pl complex_trig

animate2.html: $(GNUPLOT_LIB)/animate2.dem ./webify.pl
	export DEMOTERM="gif animate transparent noopt delay 10 size 200,200 background rgb 'black'"; ./webify.pl animate2
	mv animate2.html temp.html
	cat temp.html | sed -e 's/1.png/1.gif/g' > animate2.html
	mv animate2.1.png animate2.1.gif
	rm temp.html

showcase_plots: complex_trig.html pm3d_lighting.html
	cp violinplot.5.png showcase_plot_1.png
	cp voxel.2.png showcase_plot_2.png

%.html: $(GNUPLOT_LIB)/%.dem ./webify.pl
	./webify.pl $*

=== debian/changelog ===
gnuplot (5.4.1+dfsg1-1+deb11u1) bullseye; urgency=medium

  * Fix divide by zero vulnerability. CVE-2021-44917.  (Closes: #1002539)

 -- Anton Gladky <gladk@debian.org>  Sat, 25 Dec 2021 19:15:06 +0100

gnuplot (5.4.1+dfsg1-1) unstable; urgency=medium

  * [945257b] New upstream version 5.4.1+dfsg1
  * [0493a77] Update watch file format version to 4.
  * [3f7c63f] Ignore quilt dir
  * [ca3d15d] Refresh patches

 -- Anton Gladky <gladk@debian.org>  Thu, 03 Dec 2020 22:27:21 +0100

gnuplot (5.4.0+dfsg1-1) unstable; urgency=medium

  * [f271431] Add debian/.gitlab-ci.yml
  * [9ca5c2a] New upstream version 5.4.0+dfsg1
  * [3337ff1] Refresh patches
  * [0b0a411] Add texlive-science as BD
  * [c633c1a] Remove installing of tutorial
  * [6b6e08d] Add  Rules-Requires-Root: no

 -- Anton Gladky <gladk@debian.org>  Fri, 25 Sep 2020 20:00:27 +0200

=== debian/control ===
Source: gnuplot
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Anton Gladky <gladk@debian.org>
Section: math
Priority: optional
Rules-Requires-Root: no
Build-Depends: autoconf,
               automake,
               debhelper-compat (= 12),
               dh-lua,
               libcairo2-dev,
               libedit-dev,
               libgd-dev,
               liblua5.1-0-dev,
               libpango1.0-dev,
               libpng-dev,
               qtbase5-dev,
               qtbase5-dev-tools,
               qttools5-dev-tools,
               libqt5webkit5-dev,
               libqt5opengl5-dev,
               libqt5svg5-dev,
               libx11-dev,
               libxt-dev,
               pkg-config,
               libwxgtk3.0-gtk3-dev,
               zlib1g-dev
Build-Depends-Indep: latex2html,
                     texinfo,
                     texlive-fonts-recommended,
                     texlive-font-utils,
                     texlive-latex-base,
                     texlive-latex-extra,
                     texlive-latex-recommended,
                     texlive-science,
                     emacs
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/science-team/gnuplot
Vcs-Git: https://salsa.debian.org/science-team/gnuplot.git
Homepage: http://gnuplot.sourceforge.net/

Package: gnuplot
Architecture: all
Depends: gnuplot-qt | gnuplot-x11 | gnuplot-nox,
         ${misc:Depends}
Suggests: gnuplot-doc
Description: Command-line driven interactive plotting program.
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on. The X11-output
 is packaged in gnuplot-x11.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This metapackage is to install a full-featured gnuplot (-qt, -x11 or -nox).

Package: gnuplot-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Command-line driven interactive plotting program. Doc-package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains the additional documentation.

Package: gnuplot-nox
Architecture: any
Depends: gnuplot-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: fonts-liberation,
            groff
Suggests: gnuplot-doc
Conflicts: gnuplot-qt,
           gnuplot-x11
Provides: gnuplot
Replaces: gnuplot-qt,
          gnuplot-x11
Description: Command-line driven interactive plotting program. No-X package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on. The X11-output
 is packaged in gnuplot-x11. The QT-output is packaged in gnuplot-qt.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package is for working without an X server.

Package: gnuplot-qt
Architecture: any
Depends: gnuplot-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: gnuplot-doc
Conflicts: gnuplot-x11,
           gnuplot-nox
Provides: gnuplot-nox,
          gnuplot-x11,
          gnuplot
Replaces: gnuplot-x11,
          gnuplot-nox
Description: Command-line driven interactive plotting program. QT-package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains the terminal driver that enables gnuplot to plot
 images interactively using Qt.
 .
 The package provides gnuplot-x11 and gnuplot-nox terminals plus an
 additional QT-terminal for output.

Package: gnuplot-x11
Architecture: any
Depends: gnuplot-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: gnuplot-doc
Conflicts: gnuplot-qt,
           gnuplot-nox
Provides: gnuplot-nox,
          gnuplot
Replaces: gnuplot-qt,
          gnuplot-nox
Description: Command-line driven interactive plotting program. X-package
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains the terminal driver that enables gnuplot to plot
 images interactively under X11.

Package: gnuplot-data
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: aglfn,
         ${misc:Depends}
Description: Command-line driven interactive plotting program. Data-files
 Gnuplot is a portable command-line driven interactive data and function
 plotting utility that supports lots of output formats, including drivers
 for many printers, (La)TeX, (x)fig, Postscript, and so on. The X11-output
 is packaged in gnuplot-x11.
 .
 Data files and self-defined functions can be manipulated by the internal
 C-like language. Can perform smoothing, spline-fitting, or nonlinear fits,
 and can work with complex numbers.
 .
 This package contains data-files which are used by -nox, -x11 and -qt.

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg1,dversionmangle=s/\+dfsg\d*$// https://sf.net/gnuplot gnuplot-([\d.]+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## gnuplot 5.4.2%2Bdfsg2

=== config/mingw/Makefile ===
--- 
+++ 
@@ -164,7 +164,7 @@
 GRXPATH=c:/Source/grx249
 # or, the MGRX fork of GRX
 #MGRX=1
-MGRXPATH=c:/Source/mgrx110
+MGRXPATH=c:/Source/mgrx
 
 
 # Below you can adapt paths according to your software setup:
@@ -302,6 +302,7 @@
 
 ifdef UNICODE
   CFLAGS += -DUNICODE -D_UNICODE
+  LDFLAGS2 += -municode
 endif
 
 CFLAGS += $(CWFLAGS)
